import type { BasicEncoderSpecMap, GenerateBaseEncodeSpec, Nil, ScaleSpec, ValueOf, CrosshairSpec, CellEncodeChannels, SemanticTooltipOption, WithDefaultEncode } from '@visactor/vgrammar-core';
import { SemanticMark } from './semantic-mark';
import { GrammarMarkType } from '@visactor/vgrammar-core';
import { PlotMakType } from './enums';
export declare class Cell extends SemanticMark<BasicEncoderSpecMap['cell'], CellEncodeChannels> {
    static readonly type = PlotMakType.cell;
    constructor(id?: string | number);
    setMarkType(): GrammarMarkType;
    protected parseScaleOfEncodeX(option: ValueOf<WithDefaultEncode<BasicEncoderSpecMap['cell'], CellEncodeChannels>, CellEncodeChannels>): ScaleSpec | Nil;
    parseScaleByEncode(channel: CellEncodeChannels, option: ValueOf<WithDefaultEncode<BasicEncoderSpecMap['cell'], CellEncodeChannels>, CellEncodeChannels>): ScaleSpec | Nil;
    setDefaultCrosshair(): Record<string, Pick<CrosshairSpec, 'crosshairShape' | 'crosshairType'>>;
    setDefaultTooltip(): SemanticTooltipOption | Nil;
    convertMarkEncode(encode: WithDefaultEncode<BasicEncoderSpecMap['cell'], CellEncodeChannels>): GenerateBaseEncodeSpec<BasicEncoderSpecMap['cell']>;
}
